program Adblock;

// Adblock 1.3.6 by A.Ruzanov
// 11.02.2009

uses
  windows,
  messages,
  KOL;

const
  ni = '{ display: none !important }';
  ch = '@charset "utf-8";';
  ad = '/* Name: AdBlock+ */';
  js = 'data:text/adblock;charset=UTF-8,';
var
	adblockPath, tmpName, str, host, rule, origText: string;
  i, j, ruleLength: Integer;

function UrlUnescapeA(pszUrl, pszUnescaped: PAnsiChar; pcchUnescaped: LPDWORD;
  dwFlags: DWORD): HRESULT; stdcall; external 'shlwapi.dll' name 'UrlUnescapeA';

function UrlUnescape(Url: String): String;
 var
  buf: Array [0..4095] Of Char;
  sz: Integer;
begin
  sz := SizeOf(buf);
  UrlUnescapeA(PChar(Url), buf, @sz, $02000000);
  Result := buf;
end;

function CommandLine: String;
 var P: PChar;
begin
  P := SkipSpaces( GetCommandLine );
  while P[0] > ' ' do
    if P[0] = '"' then
    begin
      Inc(P);
      while (P[0] <> #0) and (P[0] <> '"') do
        Inc(P);
      if P[0] <> #0 then Inc(P);
    end
      else
      Inc(P);
  Result := P;
end;

function CorrectCmdLn(str: String): String;
begin
  Result := TrimRight(TrimLeft(str));
  if Length(Result) >= 2 then
    if (Result[1] = '"') and (Result[Length(Result )] = '"') then
      Result := Copy(Result, 2, Length(Result) - 2);
end;

function IsBlankStr(str: String): Boolean;
begin
  Result := (str = '') Or ( (Pos('/*', str) > 0) And (Pos('*/', str) > 0) ) Or ( (Pos('@', str) = 1) And  (Pos(';', str) = Length(str)));
end;

begin
If ParamCount = 0 Then
  begin
  MessageBox(0, PChar('Delphi Adblock for Opera 8+'), 'About', 64);
  Exit;
  end;

adblockPath := ExcludeTrailingPathDelimiter(GetStartDir);
DeleteTail(adblockPath, Length(adblockPath)-DelimiterLast(adblockPath, '\'));
adblockPath := adblockPath + 'styles\user\Adblock+.css';
tmpName := ReplaceExt(adblockPath, '.tmp');
If FileExists(tmpName) Then
  begin
  MessageBox(0, PChar('Exists the temp file: '+tmpName), 'Error', 48);
  Exit;
  end;

str := CorrectCmdLn(CommandLine);
If Pos(js, str) = 1 Then str := UrlUnescape(Copy(str, Length(js) + 1, MaxInt)) Else str := AnsiToUtf8(str);
If (str = '') Or ( (str[1] <> '/') And ((Pos('[', str) = 0) Or (Pos(']', str) = 0)) ) Then Exit;


with NewStrList^ do begin
  LoadFromFile(adblockPath);
    origText := Text;
    If LowerCase(Items[0]) <> ch Then Insert(0, ch);
    If Items[1] <> ad Then Insert(1, ad);
    If Last <> ni Then Insert(Count, ni);

    If (str[1] <> '/') Then
      begin
      If (IndexOf(str) = -1) And (IndexOf(str + ',') = -1) Then
        begin
        If not IsBlankStr(Items[Count-2]) Then Items[Count-2] := IncludeTrailingChar(Items[Count-2], ',');
        Insert(Count-1, str);
        end;
      end
    Else
       begin
       If (Pos('/unblock', str) = 1) Then
         begin
         If Pos('=', str) = 9 Then
          begin
          host := Copy(str, 10, MaxInt);
          for i := Count - 2 downto 0 do if Pos(host, Items[i]) > 0 then
            begin
            If not IsBlankStr(Items[i]) Then Delete(i);
            break;
            end;
          end
         Else If not IsBlankStr(Items[Count-2]) Then Delete(Count-2);
         end;

       If (Pos('/clear', str) = 1) Then
         begin
         for i := Count - 2 downto 0 do if not IsBlankStr(Items[i]) then
            begin
            rule := ExcludeTrailingChar(Items[i], ',') + ' > ';
            ruleLength := Length(rule);
            for j := Count - 2 downto 0 do if not IsBlankStr(Items[j]) then
              If (Length(Items[j]) > ruleLength) And (Pos(rule, Items[j]) = 1) Then Delete(j);
            end;
         end;

       If not IsBlankStr(Items[Count-2]) Then Items[Count-2] := ExcludeTrailingChar(Items[Count-2], ',');
       end;

    If origText <> Text Then
      begin
      CopyFile(PChar(adblockPath), PChar(tmpName), false);
      SaveToFile(adblockPath);
      Sleep(10);
      SaveToFile(adblockPath);
      Sleep(10);
      SaveToFile(adblockPath);
      DeleteFile(PChar(tmpName));
      end;
  Free;
end;
end.

